diff --git a/hw/ide/ahci.c b/hw/ide/ahci.c
index 17f1cbd..7e87b18 100644
--- a/hw/ide/ahci.c
+++ b/hw/ide/ahci.c
@@ -21,6 +21,7 @@
  *
  */
 
+#include "qemu/osdep.h"
 #include <hw/hw.h>
 #include <hw/pci/msi.h>
 #include <hw/i386/pc.h>
diff --git a/hw/ide/atapi.c b/hw/ide/atapi.c
index 272ab90..1fe58ab 100644
--- a/hw/ide/atapi.c
+++ b/hw/ide/atapi.c
@@ -23,6 +23,7 @@
  * THE SOFTWARE.
  */
 
+#include "qemu/osdep.h"
 #include "hw/ide/internal.h"
 #include "hw/scsi/scsi.h"
 #include "sysemu/block-backend.h"
diff --git a/hw/ide/cmd646.c b/hw/ide/cmd646.c
index 27f3da2..49294a5 100644
--- a/hw/ide/cmd646.c
+++ b/hw/ide/cmd646.c
@@ -22,6 +22,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include <hw/hw.h>
 #include <hw/i386/pc.h>
 #include <hw/pci/pci.h>
diff --git a/hw/ide/core.c b/hw/ide/core.c
index da3baab..4c46453 100644
--- a/hw/ide/core.c
+++ b/hw/ide/core.c
@@ -22,6 +22,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include <hw/hw.h>
 #include <hw/i386/pc.h>
 #include <hw/pci/pci.h>
diff --git a/hw/ide/ich.c b/hw/ide/ich.c
index 16925fa..0a13334 100644
--- a/hw/ide/ich.c
+++ b/hw/ide/ich.c
@@ -60,6 +60,7 @@
  *
  */
 
+#include "qemu/osdep.h"
 #include <hw/hw.h>
 #include <hw/pci/msi.h>
 #include <hw/i386/pc.h>
diff --git a/hw/ide/isa.c b/hw/ide/isa.c
index 9f80503..eba567c 100644
--- a/hw/ide/isa.c
+++ b/hw/ide/isa.c
@@ -22,6 +22,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include <hw/hw.h>
 #include <hw/i386/pc.h>
 #include <hw/isa/isa.h>
diff --git a/hw/ide/macio.c b/hw/ide/macio.c
index d4031b6..336784b 100644
--- a/hw/ide/macio.c
+++ b/hw/ide/macio.c
@@ -22,6 +22,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include "hw/hw.h"
 #include "hw/ppc/mac.h"
 #include "hw/ppc/mac_dbdma.h"
diff --git a/hw/ide/microdrive.c b/hw/ide/microdrive.c
index 6639dd4..5c9db80 100644
--- a/hw/ide/microdrive.c
+++ b/hw/ide/microdrive.c
@@ -22,6 +22,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include <hw/hw.h>
 #include <hw/i386/pc.h>
 #include <hw/pcmcia.h>
diff --git a/hw/ide/mmio.c b/hw/ide/mmio.c
index b6ce62a..493f65a 100644
--- a/hw/ide/mmio.c
+++ b/hw/ide/mmio.c
@@ -22,6 +22,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include "hw/hw.h"
 #include "hw/sysbus.h"
 #include "sysemu/block-backend.h"
diff --git a/hw/ide/pci.c b/hw/ide/pci.c
index 37dbc29..fa5b63b 100644
--- a/hw/ide/pci.c
+++ b/hw/ide/pci.c
@@ -22,6 +22,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include <hw/hw.h>
 #include <hw/i386/pc.h>
 #include <hw/pci/pci.h>
diff --git a/hw/ide/piix.c b/hw/ide/piix.c
index 5a26c86..df46147 100644
--- a/hw/ide/piix.c
+++ b/hw/ide/piix.c
@@ -23,6 +23,7 @@
  * THE SOFTWARE.
  */
 
+#include "qemu/osdep.h"
 #include <hw/hw.h>
 #include <hw/i386/pc.h>
 #include <hw/pci/pci.h>
diff --git a/hw/ide/qdev.c b/hw/ide/qdev.c
index 1f83109..f9d8912 100644
--- a/hw/ide/qdev.c
+++ b/hw/ide/qdev.c
@@ -16,6 +16,7 @@
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, see <http://www.gnu.org/licenses/>.
  */
+#include "qemu/osdep.h"
 #include <hw/hw.h>
 #include "sysemu/dma.h"
 #include "qemu/error-report.h"
diff --git a/hw/ide/via.c b/hw/ide/via.c
index e2da9ef..d3f7226 100644
--- a/hw/ide/via.c
+++ b/hw/ide/via.c
@@ -23,6 +23,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include <hw/hw.h>
 #include <hw/i386/pc.h>
 #include <hw/pci/pci.h>
diff --git a/tests/ahci-test.c b/tests/ahci-test.c
index 31fb1f9..6869f7f 100644
--- a/tests/ahci-test.c
+++ b/tests/ahci-test.c
@@ -22,9 +22,7 @@
  * THE SOFTWARE.
  */
 
-#include <stdint.h>
-#include <string.h>
-#include <stdio.h>
+#include "qemu/osdep.h"
 #include <getopt.h>
 #include <glib.h>
 
diff --git a/tests/ide-test.c b/tests/ide-test.c
index b864701..0d9ab4d 100644
--- a/tests/ide-test.c
+++ b/tests/ide-test.c
@@ -22,9 +22,7 @@
  * THE SOFTWARE.
  */
 
-#include <stdint.h>
-#include <string.h>
-#include <stdio.h>
+#include "qemu/osdep.h"
 
 #include <glib.h>
 
diff --git a/tests/libqos/ahci.c b/tests/libqos/ahci.c
index 6b8c556..ac6c155 100644
--- a/tests/libqos/ahci.c
+++ b/tests/libqos/ahci.c
@@ -22,6 +22,7 @@
  * THE SOFTWARE.
  */
 
+#include "qemu/osdep.h"
 #include <glib.h>
 
 #include "libqtest.h"